interface Figure {
    /* gli oggetti delle classi che realizzano questa interfaccia sono 
       caratterizzati da
         un tipo 
	 un area
    */
    int PROVA = 5;
    double area();

    String tipo();

}

class RadiceFigure {

    protected double dim1;
    protected double dim2;

    RadiceFigure(double a, double b) {
	dim1 = a;
	dim2 = b;
    }
}

class Rectangle extends RadiceFigure implements Figure{

    Rectangle(double a, double b) {
	super(a, b);
    }

    // definisce area() di Figure
    public double area() {
	return dim1 * dim2;
    }

    // definisce tipo() di Figure
    public String tipo() {
	return "Rectangle ";
    }
}

class Triangle extends RadiceFigure implements Figure {
        Triangle(double a, double b) {
                super(a, b);
        }
    // definisce area() di Figure
    public double area() {
	return dim1 * dim2 / 2;
    }

    // definisce tipo() di Figure
    public String tipo() {
	return "Triangle ";
    } 
}

class Interfacce {

    public static void main(String args[]) {

	// Figure f = new Figure(10, 10); // questo  illegale
	
	Figure figref; //  OK nessun oggetto e' stato creato

	figref = new Rectangle(9, 5);
	System.out.println(figref.tipo() + figref.area());
	figref = new Triangle(10, 8);
	System.out.println(figref.tipo() + figref.area());

	// figref.dim1 = 0 ; //anche questo e` illegale

    }
}

